## rhash 1.3.9

=== Makefile ===

include config.mak

HEADERS = calc_sums.h hash_print.h common_func.h hash_update.h file.h file_mask.h file_set.h find_file.h hash_check.h output.h parse_cmdline.h rhash_main.h win_utils.h platform.h version.h
SOURCES = calc_sums.c hash_print.c common_func.c hash_update.c file.c file_mask.c file_set.c find_file.c hash_check.c output.c parse_cmdline.c rhash_main.c win_utils.c
OBJECTS = $(SOURCES:.c=.o)
WIN_DIST_FILES = dist/MD5.bat dist/magnet.bat dist/rhashrc.sample
OTHER_FILES = configure Makefile ChangeLog INSTALL.md COPYING README.md \
  build/vc-2010/rhash.vcxproj dist/rhash.spec.in dist/rhash.1 dist/rhash.1.win.sed \
  docs/CONTRIBUTING.md docs/LIBRHASH.md librhash/Doxyfile po/rhash.pot \
  tests/test_rhash.sh tests/test1K.data
LIBRHASH_FILES  = librhash/algorithms.c librhash/algorithms.h \
  librhash/byte_order.c librhash/byte_order.h librhash/plug_openssl.c librhash/plug_openssl.h \
  librhash/rhash.c librhash/rhash.h librhash/rhash_torrent.c librhash/rhash_torrent.h \
  librhash/rhash_timing.c librhash/rhash_timing.h \
  librhash/aich.c librhash/aich.h librhash/crc32.c librhash/crc32.h \
  librhash/ed2k.c librhash/ed2k.h librhash/edonr.c librhash/edonr.h \
  librhash/gost12.c librhash/gost12.h librhash/gost94.c librhash/gost94.h \
  librhash/has160.c librhash/has160.h librhash/hex.c librhash/hex.h librhash/md4.c \
  librhash/md4.h librhash/md5.c librhash/md5.h librhash/ripemd-160.c librhash/ripemd-160.h \
  librhash/sha1.c librhash/sha1.h librhash/sha3.c librhash/sha3.h \
  librhash/sha256.c librhash/sha256.h librhash/sha512.c librhash/sha512.h \
  librhash/snefru.c librhash/snefru.h librhash/tiger.c librhash/tiger.h \
  librhash/tiger_sbox.c librhash/tth.c librhash/tth.h librhash/whirlpool.c \
  librhash/whirlpool.h librhash/whirlpool_sbox.c librhash/test_hashes.c \
  librhash/test_hashes.h librhash/torrent.h librhash/torrent.c librhash/ustd.h \
  librhash/util.h librhash/Makefile
I18N_FILES  = po/ca.po po/de.po po/en_AU.po po/es.po po/fr.po po/gl.po po/it.po po/ro.po po/ru.po po/uk.po
ALL_FILES   = $(SOURCES) $(HEADERS) $(LIBRHASH_FILES) $(OTHER_FILES) $(WIN_DIST_FILES) $(I18N_FILES)
SPECFILE    = dist/rhash.spec
LIBRHASH_PC = dist/librhash.pc
RHASH_NAME     = rhash
RHASH_BINARY   = rhash$(EXEC_EXT)
TEST_OPTIONS   =
RPMTOP  = rpms
RPMDIRS = SOURCES SPECS BUILD SRPMS RPMS
INSTALL_PROGRAM = $(INSTALL) -m 755
INSTALL_DATA    = $(INSTALL) -m 644

all: $(BUILD_TARGETS)
install: build-install-binary install-data install-symlinks $(EXTRA_INSTALL)
build-static: $(RHASH_STATIC)
build-shared: $(RHASH_SHARED)
lib-shared: $(LIBRHASH_SHARED)
lib-static: $(LIBRHASH_STATIC)
install-data: install-man install-conf
uninstall: uninstall-binary uninstall-data uninstall-symlinks uninstall-lib uninstall-gmo uninstall-pkg-config

config.mak:
	echo "Run the ./configure script first" && false

# creating archives
WIN_SUFFIX     = win32
PACKAGE_NAME   = $(RHASH_NAME)-$(VERSION)
ARCHIVE_TARGZ  = $(PACKAGE_NAME)-src.tar.gz
ARCHIVE_TARGZ_CORE     = $(RHASH_NAME)-core-$(VERSION)-src.tar.gz
ARCHIVE_TARGZ_BINDINGS = $(RHASH_NAME)-bindings-$(VERSION)-src.tar.gz
ARCHIVE_TARGZ_DEB      = $(RHASH_NAME)_$(VERSION).orig.tar.gz
ARCHIVE_XZ     = $(PACKAGE_NAME)-src.tar.xz
ARCHIVE_ZIP    = $(PACKAGE_NAME)-$(WIN_SUFFIX).zip
WIN_ZIP_DIR    = RHash-$(VERSION)-$(WIN_SUFFIX)
dist: tgz
win-dist: zip
zip: $(ARCHIVE_ZIP)
dgz: check $(ARCHIVE_TARGZ_DEB)

build-install-binary: $(BUILD_TARGETS)
	+$(MAKE) install-binary

mkdir-bin:
	$(INSTALL) -d $(BINDIR)

# install binary without (re-)compilation
install-binary: mkdir-bin
	$(INSTALL_PROGRAM) $(RHASH_BINARY) $(BINDIR)/$(RHASH_BINARY)

install-man:
	$(INSTALL) -d $(MANDIR)/man1
	$(INSTALL_DATA) dist/rhash.1 $(MANDIR)/man1/rhash.1

install-conf:
	$(INSTALL) -d $(SYSCONFDIR)
	tr -d \\r < dist/rhashrc.sample > rc.tmp && $(INSTALL_DATA) rc.tmp $(SYSCONFDIR)/rhashrc
	rm -f rc.tmp

# dependencies should be properly set, otherwise 'make -j<n>' can fail
install-symlinks: mkdir-bin install-man install-binary
	cd $(BINDIR) && for f in $(SYMLINKS); do $(LN_S) $(RHASH_BINARY) $$f$(EXEC_EXT); done
	cd $(MANDIR)/man1 && for f in $(SYMLINKS); do $(LN_S) rhash.1 $$f.1; done

install-pkg-config:
	$(INSTALL) -d $(PKGCONFIGDIR)
	$(INSTALL_DATA) $(LIBRHASH_PC) $(PKGCONFIGDIR)/

uninstall-binary:
	rm -f $(BINDIR)/$(RHASH_BINARY)

uninstall-data:
	rm -f $(MANDIR)/man1/rhash.1

uninstall-symlinks:
	for f in $(SYMLINKS); do rm -f $(BINDIR)/$$f$(EXEC_EXT) $(MANDIR)/man1/$$f.1; done

uninstall-pkg-config:
	rm -f $(PKGCONFIGDIR)/librhash.pc

uninstall-lib:
	+cd librhash && $(MAKE) uninstall-lib

install-lib-static: $(LIBRHASH_STATIC) install-lib-headers
	+cd librhash && $(MAKE) install-lib-static

install-lib-shared: $(LIBRHASH_SHARED)
	+cd librhash && $(MAKE) install-lib-shared

install-lib-headers:
	+cd librhash && $(MAKE) install-lib-headers

install-lib-so-link:
	+cd librhash && $(MAKE) install-so-link

$(LIBRHASH_SHARED): $(LIBRHASH_FILES)
	+cd librhash && $(MAKE) lib-shared

$(LIBRHASH_STATIC): $(LIBRHASH_FILES)
	+cd librhash && $(MAKE) lib-static

test-lib: test-lib-$(BUILD_TYPE)
test-lib-static: $(LIBRHASH_STATIC)
	+cd librhash && $(MAKE) test-static

test-lib-shared: $(LIBRHASH_SHARED)
	+cd librhash && $(MAKE) test-shared

test-libs: $(LIBRHASH_STATIC) $(LIBRHASH_SHARED)
	+cd librhash && $(MAKE) test-static test-shared

test-full:
	+$(MAKE) TEST_OPTIONS=--full test

test: test-$(BUILD_TYPE)
test-static: $(RHASH_STATIC)
	/bin/sh tests/test_rhash.sh $(TEST_OPTIONS) ./$(RHASH_STATIC)

test-shared: $(RHASH_SHARED)
	/bin/sh tests/test_rhash.sh --shared $(TEST_OPTIONS) ./$(RHASH_SHARED)

print-info: lib-$(BUILD_TYPE)
	+cd librhash && $(MAKE) print-info

# check that source tree is consistent
check:
	grep -q '\* === Version $(VERSION) ===' ChangeLog
	grep -q '^#define VERSION "$(VERSION)"' version.h
	test ! -f bindings/version.properties || grep -q '^version=$(VERSION)$$' bindings/version.properties

$(RHASH_STATIC): $(OBJECTS) $(LIBRHASH_STATIC)
	$(CC) $(OBJECTS) $(LIBRHASH_STATIC) $(BIN_STATIC_LDFLAGS) -o $@

$(RHASH_SHARED): $(OBJECTS) $(LIBRHASH_SHARED)
	$(CC) $(OBJECTS) $(LIBRHASH_SHARED) $(LDFLAGS) -o $@

# NOTE: dependences were generated by 'gcc -Ilibrhash -MM *.c'
# we are using plain old makefile style to support BSD make
calc_sums.o: calc_sums.c platform.h calc_sums.h common_func.h file.h \
 hash_check.h hash_print.h output.h parse_cmdline.h rhash_main.h \
 win_utils.h librhash/rhash.h librhash/rhash_torrent.h
	$(CC) -c $(CFLAGS) $< -o $@

common_func.o: common_func.c common_func.h parse_cmdline.h version.h \
 win_utils.h
	$(CC) -c $(CFLAGS) $< -o $@

file.o: file.c file.h common_func.h platform.h win_utils.h
	$(CC) -c $(CFLAGS) $< -o $@

file_mask.o: file_mask.c file_mask.h common_func.h
	$(CC) -c $(CFLAGS) $< -o $@

file_set.o: file_set.c file_set.h calc_sums.h common_func.h file.h \
 hash_check.h hash_print.h output.h parse_cmdline.h rhash_main.h \
 librhash/rhash.h
	$(CC) -c $(CFLAGS) $< -o $@

find_file.o: find_file.c platform.h find_file.h common_func.h file.h \
 output.h win_utils.h
	$(CC) -c $(CFLAGS) $< -o $@

hash_check.o: hash_check.c hash_check.h hash_print.h common_func.h \
 output.h parse_cmdline.h librhash/rhash.h
	$(CC) -c $(CFLAGS) $< -o $@

hash_print.o: hash_print.c hash_print.h calc_sums.h common_func.h file.h \
 hash_check.h output.h parse_cmdline.h win_utils.h librhash/rhash.h
	$(CC) -c $(CFLAGS) $< -o $@

hash_update.o: hash_update.c calc_sums.h common_func.h file.h \
 hash_check.h file_set.h file_mask.h hash_print.h hash_update.h output.h \
 parse_cmdline.h rhash_main.h win_utils.h
	$(CC) -c $(CFLAGS) $< -o $@

output.o: output.c platform.h calc_sums.h common_func.h file.h \
 hash_check.h output.h parse_cmdline.h rhash_main.h win_utils.h \
 librhash/rhash.h
	$(CC) -c $(CFLAGS) $< -o $@

parse_cmdline.o: parse_cmdline.c parse_cmdline.h common_func.h file.h \
 file_mask.h find_file.h hash_print.h output.h rhash_main.h win_utils.h \
 librhash/rhash.h
	$(CC) -c $(CFLAGS) $(CONFCFLAGS) $< -o $@

rhash_main.o: rhash_main.c rhash_main.h calc_sums.h common_func.h file.h \
 hash_check.h file_mask.h find_file.h hash_print.h hash_update.h \
 parse_cmdline.h output.h win_utils.h librhash/rhash.h
	$(CC) -c $(CFLAGS) $< -o $@

win_utils.o: win_utils.c win_utils.h common_func.h file.h parse_cmdline.h \
 rhash_main.h
	$(CC) -c $(CFLAGS) $< -o $@

dist/rhash.1.win.html: dist/rhash.1 dist/rhash.1.win.sed
	sed -f dist/rhash.1.win.sed dist/rhash.1 | rman -fHTML -roff | \
	sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > dist/rhash.1.win.html
#	verify the result
	grep -q "utf8" dist/rhash.1.win.html
	grep -q "APPDATA" dist/rhash.1.win.html

dist/rhash.1.html: dist/rhash.1
	-which rman 2>/dev/null && (rman -fHTML -roff dist/rhash.1 | sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > $@)

dist/rhash.1.txt: dist/rhash.1
	-which groff &>/dev/null && (groff -t -e -mandoc -Tascii dist/rhash.1 | sed -e 's/.\[[0-9]*m//g' > $@)

permissions:
	find . build dist docs librhash po tests -maxdepth 1 -type f -exec chmod -x '{}' \;
	chmod +x configure tests/test_rhash.sh

copy-dist: $(ALL_FILES) permissions
	rm -rf $(PACKAGE_NAME)
	mkdir $(PACKAGE_NAME)
	cp -rl --parents $(ALL_FILES) $(PACKAGE_NAME)/

tgz-core: check
	+$(MAKE) copy-dist PACKAGE_NAME=$(PACKAGE_NAME)-core
	tar czf $(ARCHIVE_TARGZ_CORE) --owner=root --group=root $(PACKAGE_NAME)-core/
	rm -rf $(PACKAGE_NAME)-core

tgz-bindings:
	+cd bindings && $(MAKE) gzip ARCHIVE_GZIP=../$(ARCHIVE_TARGZ_BINDINGS)

tgz: check clean-bindings
	+$(MAKE) copy-dist
	+cd bindings && $(MAKE) copy-dist COPYDIR=../$(PACKAGE_NAME)/bindings
	tar czf $(ARCHIVE_TARGZ) --owner=root:0 --group=root:0 $(PACKAGE_NAME)/
	rm -rf $(PACKAGE_NAME)

xz: check clean-bindings
	+$(MAKE) copy-dist
	+cd bindings && $(MAKE) copy-dist COPYDIR=../$(PACKAGE_NAME)/bindings
	tar cJf $(ARCHIVE_XZ) --owner=root:0 --group=root:0 $(PACKAGE_NAME)/
	rm -rf $(PACKAGE_NAME)

$(ARCHIVE_ZIP): $(WIN_DIST_FILES) dist/rhash.1.win.html
	test -s dist/rhash.1.win.html && test -x $(RHASH_BINARY)
	-rm -rf $(WIN_ZIP_DIR)
	mkdir $(WIN_ZIP_DIR)
	cp $(RHASH_BINARY) ChangeLog $(WIN_DIST_FILES) $(WIN_ZIP_DIR)/
	cp dist/rhash.1.win.html $(WIN_ZIP_DIR)/rhash-doc.html
	zip -9r $(ARCHIVE_ZIP) $(WIN_ZIP_DIR)
	rm -rf $(WIN_ZIP_DIR)

$(ARCHIVE_TARGZ_DEB) : $(ALL_FILES)
	+$(MAKE) tgz
	mv -f $(ARCHIVE_TARGZ) $(ARCHIVE_TARGZ_DEB)

# rpm packaging
$(SPECFILE): $(SPECFILE).in config.mak
	sed -e 's/@VERSION@/$(VERSION)/' $(SPECFILE).in > $(SPECFILE)

rpm: tgz
	-for i in $(RPMDIRS); do mkdir -p $(RPMTOP)/$$i; done
	cp -f $(ARCHIVE_TARGZ) $(RPMTOP)/SOURCES
	rpmbuild -ba --clean --define "_topdir `pwd`/$(RPMTOP)" $(SPECFILE)
	mv -f `find $(RPMTOP) -name "*rhash*-$(VERSION)*.rpm"` .
	rm -rf $(RPMTOP)

clean-bindings:
	+cd bindings && $(MAKE) clean

clean-local:
	rm -f *.o $(RHASH_SHARED) $(RHASH_STATIC)
	rm -f po/*.gmo po/*.po~

distclean: clean-local
	rm -f config.log config.mak $(SPECFILE) $(LIBRHASH_PC)
	+cd librhash && $(MAKE) distclean

clean: clean-local
	+cd librhash && $(MAKE) clean

update-po:
	xgettext *.c -k_ -cTRANSLATORS -o po/rhash.pot \
		--msgid-bugs-address='Aleksey <rhash.admin@gmail.com>' --package-name='RHash'
	for f in $(I18N_FILES); do \
		msgmerge -U $$f po/rhash.pot; \
	done

compile-gmo:
	for f in $(I18N_FILES); do \
		g=`basename $$f .po`; \
		msgfmt -o po/$$g.gmo $$f; \
	done

install-gmo: compile-gmo
	for f in $(I18N_FILES); do \
		l=`basename $$f .po`; \
		$(INSTALL) -d $(LOCALEDIR)/$$l/LC_MESSAGES; \
		$(INSTALL_DATA) po/$$l.gmo $(LOCALEDIR)/$$l/LC_MESSAGES/rhash.mo; \
	done

uninstall-gmo:
	for f in $(I18N_FILES); do \
		rm -f $(LOCALEDIR)/`basename $$f .po`/LC_MESSAGES/rhash.mo; \
	done

.PHONY: all build-shared build-static lib-shared lib-static clean clean-bindings distclean clean-local \
	test test-shared test-static test-full test-lib test-libs test-lib-shared test-lib-static \
	install build-install-binary install-binary install-lib-shared install-lib-static \
	install-lib-headers install-lib-so-link install-conf install-data install-gmo install-man \

=== librhash/Makefile ===
# Makefile for LibRHash

include config.mak

HEADERS = algorithms.h byte_order.h plug_openssl.h rhash.h rhash_timing.h rhash_torrent.h aich.h crc32.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h sha3.h ripemd-160.h gost12.h gost94.h has160.h snefru.h tiger.h tth.h torrent.h ustd.h util.h whirlpool.h
SOURCES = algorithms.c byte_order.c plug_openssl.c rhash.c rhash_timing.c rhash_torrent.c aich.c crc32.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c sha3.c ripemd-160.c gost12.c gost94.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c whirlpool.c whirlpool_sbox.c
OBJECTS = $(SOURCES:.c=.o)
LIB_HEADERS = rhash.h rhash_torrent.h
SO_HEADERS = $(LIB_HEADERS) $(LEGACY_HEADERS)
TEST_STATIC = test_static$(EXEC_EXT)
TEST_SHARED = test_shared$(EXEC_EXT)
INSTALL_DATA    = $(INSTALL) -m 644
INSTALL_SHARED  = $(INSTALL) -m 644

all: $(BUILD_TARGETS)
lib-static: $(LIBRHASH_STATIC)
lib-shared: $(LIBRHASH_SHARED)
libs-all: lib-static lib-shared
uninstall-lib: uninstall-lib-shared uninstall-lib-static uninstall-so-link

config.mak:
	echo "Run the ./configure script first" && false

install-lib-static: $(LIBRHASH_STATIC)
	$(INSTALL) -d $(LIBDIR)
	$(INSTALL_DATA) $(LIBRHASH_STATIC) $(LIBDIR)/

install-lib-shared: $(LIBRHASH_SHARED) $(EXTRA_INSTALL_LIBSHARED)
	$(INSTALL) -d $(SO_DIR)
	$(INSTALL_SHARED) $(LIBRHASH_SHARED) $(SO_DIR)/

install-implib:
	$(INSTALL) -d $(LIBDIR)
	$(INSTALL_SHARED) $(LIBRHASH_IMPLIB) $(LIBDIR)/

install-so-link:
	$(INSTALL) -d $(LIBDIR)
	ln -s $(LIBRHASH_SHARED) $(LIBDIR)/$(LIBRHASH_SOLINK)

uninstall-lib-static: uninstall-lib-headers
	rm -f $(LIBDIR)/$(LIBRHASH_STATIC)

uninstall-lib-shared: $(EXTRA_UNINSTALL_LIBSHARED)
	rm -f $(SO_DIR)/$(LIBRHASH_SHARED)

uninstall-implib:
	rm -f $(LIBDIR)/$(LIBRHASH_IMPLIB)

uninstall-so-link:
	rm -f $(LIBDIR)/$(LIBRHASH_SOLINK)

install-lib-headers:
	$(INSTALL) -d $(INCDIR)
	$(INSTALL_DATA) $(LIB_HEADERS) $(INCDIR)/

uninstall-lib-headers:
	for f in $(LIB_HEADERS); do rm -f "$(INCDIR)/$$f"; done

# not using GNU make extensions for compatibility with Unix/*BSD make
#%.o: %.c
#	$(CC) -c $(CFLAGS) $< -o $@

# NOTE: dependences were generated by 'gcc -MM -DUSE_OPENSSL *.c'
# we are using plain old makefile style to support BSD make
aich.o: aich.c byte_order.h ustd.h algorithms.h rhash.h aich.h sha1.h
	$(CC) -c $(CFLAGS) $< -o $@

algorithms.o: algorithms.c byte_order.h ustd.h rhash.h algorithms.h \
 aich.h sha1.h crc32.h ed2k.h md4.h edonr.h gost12.h gost94.h has160.h \
 md5.h ripemd-160.h snefru.h sha256.h sha512.h sha3.h tiger.h torrent.h \
 tth.h whirlpool.h
	$(CC) -c $(CFLAGS) $< -o $@

byte_order.o: byte_order.c byte_order.h ustd.h
	$(CC) -c $(CFLAGS) $< -o $@

crc32.o: crc32.c byte_order.h ustd.h crc32.h
	$(CC) -c $(CFLAGS) $< -o $@

ed2k.o: ed2k.c ed2k.h md4.h ustd.h
	$(CC) -c $(CFLAGS) $< -o $@

edonr.o: edonr.c byte_order.h ustd.h edonr.h
	$(CC) -c $(CFLAGS) $< -o $@

gost12.o: gost12.c gost12.h ustd.h byte_order.h
	$(CC) -c $(CFLAGS) $< -o $@

gost94.o: gost94.c gost94.h ustd.h byte_order.h
	$(CC) -c $(CFLAGS) $< -o $@

has160.o: has160.c byte_order.h ustd.h has160.h
	$(CC) -c $(CFLAGS) $< -o $@

hex.o: hex.c hex.h ustd.h
	$(CC) -c $(CFLAGS) $< -o $@

md4.o: md4.c byte_order.h ustd.h md4.h
	$(CC) -c $(CFLAGS) $< -o $@

md5.o: md5.c byte_order.h ustd.h md5.h
	$(CC) -c $(CFLAGS) $< -o $@

plug_openssl.o: plug_openssl.c algorithms.h rhash.h byte_order.h ustd.h \
 plug_openssl.h
	$(CC) -c $(CFLAGS) $< -o $@

rhash.o: rhash.c byte_order.h ustd.h algorithms.h rhash.h torrent.h \
 sha1.h plug_openssl.h util.h hex.h
	$(CC) -c $(CFLAGS) $< -o $@

rhash_timing.o: rhash_timing.c byte_order.h ustd.h rhash.h rhash_timing.h
	$(CC) -c $(CFLAGS) $< -o $@

rhash_torrent.o: rhash_torrent.c algorithms.h rhash.h byte_order.h ustd.h \
 torrent.h sha1.h rhash_torrent.h
	$(CC) -c $(CFLAGS) $< -o $@

ripemd-160.o: ripemd-160.c byte_order.h ustd.h ripemd-160.h
	$(CC) -c $(CFLAGS) $< -o $@

sha1.o: sha1.c byte_order.h ustd.h sha1.h
	$(CC) -c $(CFLAGS) $< -o $@

sha256.o: sha256.c byte_order.h ustd.h sha256.h
	$(CC) -c $(CFLAGS) $< -o $@

sha3.o: sha3.c byte_order.h ustd.h sha3.h
	$(CC) -c $(CFLAGS) $< -o $@

sha512.o: sha512.c byte_order.h ustd.h sha512.h
	$(CC) -c $(CFLAGS) $< -o $@

snefru.o: snefru.c byte_order.h ustd.h snefru.h
	$(CC) -c $(CFLAGS) $< -o $@

test_hashes.o: test_hashes.c byte_order.h ustd.h rhash_timing.h \
 rhash_torrent.h rhash.h test_hashes.h
	$(CC) -c $(CFLAGS) $< -o $@

tiger.o: tiger.c byte_order.h ustd.h tiger.h
	$(CC) -c $(CFLAGS) $< -o $@

tiger_sbox.o: tiger_sbox.c byte_order.h ustd.h
	$(CC) -c $(CFLAGS) $< -o $@

torrent.o: torrent.c byte_order.h ustd.h algorithms.h rhash.h hex.h \
 torrent.h sha1.h
	$(CC) -c $(CFLAGS) $< -o $@

tth.o: tth.c byte_order.h ustd.h tth.h tiger.h
	$(CC) -c $(CFLAGS) $< -o $@

whirlpool.o: whirlpool.c byte_order.h ustd.h whirlpool.h
	$(CC) -c $(CFLAGS) $< -o $@

whirlpool_sbox.o: whirlpool_sbox.c byte_order.h ustd.h
	$(CC) -c $(CFLAGS) $< -o $@

# build shared library
$(EXPORTS_FILE): $(SO_HEADERS)
	sed -ne '1s/.*/{ global:/p; s/^RHASH_API.* \(rhash_[a-z0-9_]*\)(.*/  \1;/p; $$s/.*/local: *; };/p' $(SO_HEADERS) > $@

$(LIBRHASH_SOLINK):
	rm -f $(LIBRHASH_SOLINK)
	ln -s $(LIBRHASH_SHARED) $(LIBRHASH_SOLINK)

$(LIBRHASH_SHARED): $(SOURCES) $(EXPORTS_TARGET) $(SOLINK_TARGET)
	$(CC) $(SHARED_CFLAGS) $(SOURCES) $(SHARED_LDFLAGS) -o $@

# build static library
$(LIBRHASH_STATIC): $(OBJECTS)
	$(AR) cqs $@ $(OBJECTS)

# test targets
$(TEST_SHARED): $(LIBRHASH_SHARED) test_hashes.o
	$(CC) $(CFLAGS) test_hashes.o $(LIBRHASH_SHARED) $(LDFLAGS) -o $@

$(TEST_STATIC): $(LIBRHASH_STATIC) test_hashes.o
	$(CC) $(CFLAGS) test_hashes.o $(LIBRHASH_STATIC) $(BIN_STATIC_LDFLAGS) -o $@

test: $(TEST_TARGETS)
test-static: $(TEST_STATIC)
	./$(TEST_STATIC)
test-shared: $(TEST_SHARED)
	LD_LIBRARY_PATH=.:$(LD_LIBRARY_PATH) DYLD_LIBRARY_PATH=.:$(DYLD_LIBRARY_PATH) ./$(TEST_SHARED)

print-info: print-info-$(BUILD_TYPE)
print-info-static: $(TEST_STATIC)
	./$(TEST_STATIC) --info
print-info-shared: $(TEST_SHARED)
	LD_LIBRARY_PATH=.:$(LD_LIBRARY_PATH) DYLD_LIBRARY_PATH=.:$(DYLD_LIBRARY_PATH) ./$(TEST_SHARED) --info

distclean: clean
	rm -f config.mak

clean:
	rm -f *.o $(LIBRHASH_STATIC) $(LIBRHASH_SHARED) $(TEST_STATIC) $(TEST_SHARED) $(RM_FILES)

.PHONY: all clean distclean install-lib-headers install-lib-shared install-lib-static \
	install-so-link libs-all lib-shared lib-static test test-shared test-static \
	print-info print-info-static print-info-shared uninstall-lib-headers \
	uninstall-lib uninstall-lib-shared uninstall-lib-static uninstall-so-link \
	install-implib uninstall-implib

=== bindings/java/native/Makefile ===
#!/usr/bin/make -f

# This file is a part of Java Bindings for Librhash
#
# Copyright (c) 2011, Sergey Basalaev <sbasalaev@gmail.com>
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
# REGARD TO THIS SOFTWARE  INCLUDING ALL IMPLIED WARRANTIES OF  MERCHANTABILITY
# AND FITNESS.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
# INDIRECT,  OR CONSEQUENTIAL DAMAGES  OR ANY DAMAGES WHATSOEVER RESULTING FROM
# LOSS OF USE,  DATA OR PROFITS,  WHETHER IN AN ACTION OF CONTRACT,  NEGLIGENCE
# OR OTHER TORTIOUS ACTION,  ARISING OUT OF  OR IN CONNECTION  WITH THE USE  OR
# PERFORMANCE OF THIS SOFTWARE.

CC ?= gcc
JAVAC ?= javac
CFLAGS ?= -g -O2
LDFLAGS ?=
LIBRHASH_INC ?=
LIBRHASH_LD  ?=
ALLLDFLAGS = $(LDFLAGS) -lrhash $(LIBRHASH_LD)
ALLCFLAGS = $(CFLAGS) $(LIBRHASH_INC) -fPIC

#Platform dependent
JAVAC_PATH = $(shell readlink -f $(shell which $(JAVAC)))
JDK_HOME ?=$(realpath $(dir $(JAVAC_PATH))/..)
JNI_CFLAGS1 = $(shell test -d "$(JDK_HOME)/include" && echo -I$(JDK_HOME)/include)
JNI_CFLAGS2 = $(shell test -d "$(JDK_HOME)/include/linux" && echo -I$(JDK_HOME)/include/linux)
JNI_CFLAGS ?= $(JNI_CFLAGS1) $(JNI_CFLAGS2)
LIB_PREFIX ?= lib
LIB_SUFFIX ?= .so

OBJECTS = bindings.o digest.o
LIBRARY = $(LIB_PREFIX)rhash-jni$(LIB_SUFFIX)

all: $(LIBRARY)

bindings.o: bindings.c bindings.h
	$(CC) $(ALLCFLAGS) $(JNI_CFLAGS) -c $< -o $@

digest.o: digest.c digest.h
	$(CC) $(ALLCFLAGS) -c $< -o $@

$(LIBRARY): $(OBJECTS)
	$(CC) -shared -o $@ $(OBJECTS) $(ALLLDFLAGS)

clean:
	rm -f *.o $(LIBRARY)

=== debian/changelog ===
rhash (1.3.9-1) unstable; urgency=medium

  [Jelmer Vernooĳ]
  * d/upstream/metadata: Fix YAML syntax

  [Samuel Henrique]
  * d/salsa-ci.yml: Enable salsa CI pipelines

  [Aleksey Kravchenko]
  * New upstream release version 1.3.9
  * d/upstream/metadata: Fill upstream metadata fields
  * d/upstream/signing-key.asc: Update upstream public key
  * d/patches/01_fix_uk_po.patch: Fix uk translation
  * d/rules: remove override_dh_strip to finish debug symbol migration
  * d/control
    - Bump Standards-Version to 4.4.1
    - Add Rules-Requires-Root: no
    - Switch Build-Depends from debhelper to debhelper-compat level 12
  * d/compat: Drop obsolete d/compat
  * d/copyright: project license got changed to BSD Zero Clause License

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Tue, 17 Dec 2019 22:13:10 +0300

=== debian/control ===
Source: rhash
Section: utils
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Aleksey Kravchenko <rhash.admin@gmail.com>
Build-Depends: debhelper-compat (= 12), dpkg-dev (>= 1.16.2), libssl-dev (>= 1.0.0)
Standards-Version: 4.4.1
Homepage: http://rhash.sourceforge.net
Vcs-Git: https://salsa.debian.org/pkg-security-team/rhash.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/rhash
Rules-Requires-Root: no

Package: rhash
Architecture: any
Depends: librhash0 (>= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl1.1 | libssl1.0.2 | libssl1.0.0
Description: utility for computing hash sums and magnet links
 RHash is a console utility for calculation and verification of magnet links
 and a wide range of hash sums like CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Output in a predefined (SFV, BSD-like) or a user-defined format.
  * Can calculate Magnet links.
  * Ability to process directories recursively.
  * Updating hash files (adding hash sums of files missing in the hash file).
  * Portability: the program works the same on Linux, *BSD or Windows.

Package: librhash0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl1.1 | libssl1.0.2 | libssl1.0.0
Multi-Arch: same
Description: shared library for hash functions computing
 LibRHash is a professional, portable, thread-safe C library for computing
 magnet links and a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1,
 SHA256, SHA512, AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH,
 GOST R 34.11-94, RIPEMD-160, HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Small and easy to learn interface.
  * Hi-level and Low-level API.
  * Allows calculating of several hash functions simultaneously.
  * Portability: the library works on Linux, *BSD and Windows.

Package: librhash-dev
Architecture: any
Section: libdevel
Depends: librhash0 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: header files and a static library for librhash
 LibRHash is a professional, portable, thread-safe C library for computing
 magnet links and a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1,
 SHA256, SHA512, AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH,
 GOST R 34.11-94, RIPEMD-160, HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This package contains LibRHash static library and header files.

## rhash 1.4.0

=== debian/changelog ===
rhash (1.4.0-1) unstable; urgency=medium

  [ Aleksey Kravchenko ]
  * New upstream version 1.4.0
  * debian/patches:
    - drop already integrated into upstream patch
    - pick commit from upstream with bugfix for file-lists
  * d/control
    - Bump Standards-Version to 4.5.0
    - Bump Build-Depends debhelper-compat level to 13
    - Build-Depends: increase libssl version up to 1.1

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Sun, 19 Jul 2020 03:13:21 +0300

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Aleksey Kravchenko <rhash.admin@gmail.com>
-Build-Depends: debhelper-compat (= 12), dpkg-dev (>= 1.16.2), libssl-dev (>= 1.0.0)
-Standards-Version: 4.4.1
+Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2), libssl-dev (>= 1.1.0)
+Standards-Version: 4.5.0
 Homepage: http://rhash.sourceforge.net
 Vcs-Git: https://salsa.debian.org/pkg-security-team/rhash.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/rhash
@@ -13,7 +13,7 @@
 Package: rhash
 Architecture: any
 Depends: librhash0 (>= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
-Recommends: libssl1.1 | libssl1.0.2 | libssl1.0.0
+Recommends: libssl1.1
 Description: utility for computing hash sums and magnet links
  RHash is a console utility for calculation and verification of magnet links
  and a wide range of hash sums like CRC32, MD4, MD5, SHA1, SHA256, SHA512,
@@ -33,7 +33,7 @@
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: libssl1.1 | libssl1.0.2 | libssl1.0.0
+Recommends: libssl1.1
 Multi-Arch: same
 Description: shared library for hash functions computing
  LibRHash is a professional, portable, thread-safe C library for computing

## rhash 1.4.1

=== bindings/Makefile ===
VERSION := $(shell sed -ne 's/^version=\(.*\)/\1/p' version.properties)
BINDINGS = java mono perl python ruby php
FILES = Makefile version.properties ChangeLog COPYING
DESTDIR =
PREFIX = /usr/local
RUBY ?= ruby
PYTHON ?= python
PERL ?= perl
PERL_LIBRHASH_TYPE ?= auto
PERL_OPTIMIZE ?= -O2 -g -Wall
ARCHIVE_GZIP = rhash-bindings-$(VERSION)-src.tar.gz
COPYDIR = rhash-bindings-$(VERSION)
CP = cp -l --parents

all: configure build test
clean: distclean

configure: $(patsubst %, configure-%, $(filter perl ruby php, $(BINDINGS)))
build: $(patsubst %, build-%, $(BINDINGS))
test: $(patsubst %, test-%, $(BINDINGS))
install: $(patsubst %, install-%, $(filter perl ruby php, $(BINDINGS)))
distclean: $(patsubst %, clean-%, $(BINDINGS))

configure-perl: perl/Makefile
configure-ruby: ruby/Makefile
configure-php: php/Makefile

perl/Makefile: perl/Makefile.PL
	cd perl && LIBRHASH="$(PERL_LIBRHASH_TYPE)" $(PERL) Makefile.PL INSTALLDIRS=vendor

php/Makefile: php/config.m4
	cd php && phpize && ./configure --with-rhash

ruby/Makefile: ruby/extconf.rb
	$(RUBY) -C ruby extconf.rb

build-java:
	+$(MAKE) -C java build-binary

build-perl: configure-perl
	+$(MAKE) -C perl OPTIMIZE="$(PERL_OPTIMIZE)"

build-php: configure-php
	+$(MAKE) -C php

build-python:
# not required

build-ruby: configure-ruby
	+$(MAKE) -C ruby

build-mono:
	+$(MAKE) -C mono

test-java:
	+$(MAKE) -C java test

test-perl:
	+$(MAKE) -C perl test

test-php:
	+$(MAKE) -C php test TEST_PHP_ARGS=-q

test-ruby:
	$(RUBY) -C ruby -I. test_rhash.rb

test-mono:
	+$(MAKE) -C mono test

test-python:
	$(PYTHON) python/test_rhash.py

install-ruby:
# clear MAKEFLAGS to overcome ruby1.8 mkmf concurrency bug
	+MAKEFLAGS= $(MAKE) -C ruby install DESTDIR=$(DESTDIR) sitedir=$(DESTDIR)/usr/lib/ruby

install-perl:
	+$(MAKE) -C perl install DESTDIR=$(DESTDIR)

install-php:
	+$(MAKE) -C php install INSTALL_ROOT=$(DESTDIR)

copy-dist:
	mkdir -p $(COPYDIR)
	find java ruby python -type f -regex '.*\(\.\([hc]\|java\|py\|rb\|txt\)\|Makefile\)' -exec $(CP) '{}' $(COPYDIR)/ \;
	find mono -type f -regex '.*\(\.\([hc]\|cs\|xml\|txt\|snk\|sln\|csproj\|config\)\|Makefile\)' -exec $(CP) '{}' "$(COPYDIR)/" \;
	$(CP) $(shell sed -e 's/\([^ ]*\).*/perl\/\1/' perl/MANIFEST) "$(COPYDIR)/"
	find php -type f -regex '.*\.\(m4\|c\|h\|phpt\)' -exec $(CP) '{}' "$(COPYDIR)/" \;
	$(CP) $(FILES) "$(COPYDIR)/"

gzip: distclean
	rm -rf "$(COPYDIR)" $(ARCHIVE_GZIP)
	+$(MAKE) copy-dist
	tar -czf $(ARCHIVE_GZIP) --owner=root:0 --group=root:0 "$(COPYDIR)"
	rm -rf "$(COPYDIR)"

PERL_PKG_VER = $(shell [ -f perl/Rhash.pm ] && sed -ne "s/^our \+.VERSION *= *'\([0-9\.]*\)';/\1/p;" perl/Rhash.pm)
PERL_PKG = Crypt-RHash-$(PERL_PKG_VER)

cpan:
	[ -f ../librhash/rhash.h ]
	echo "$(PERL_PKG_VER)" | grep -q '^[0-9\.]\+$$'
	rm -rf $(PERL_PKG)/ $(PERL_PKG).tar.gz
	mkdir -p $(PERL_PKG)/librhash/
	grep -q / perl/MANIFEST && mkdir -p `sed -ne '/\//s/\([^\/]*\/\).*/$(PERL_PKG)\/\1/p' perl/MANIFEST | sort | uniq`
	for f in `sed 's/ .*//' perl/MANIFEST`; do cp perl/$$f $(PERL_PKG)/$$f; done
	cp ../docs/CONTRIBUTING.md ../COPYING $(PERL_PKG)/
	cp ../librhash/*.[hc] ../version.h $(PERL_PKG)/librhash/
	( echo CONTRIBUTING.md; echo COPYING ) >> $(PERL_PKG)/MANIFEST
	find $(PERL_PKG)/librhash/ -type f -printf "librhash/%f\n" | sort >> $(PERL_PKG)/MANIFEST
	tar -czf $(PERL_PKG).tar.gz --owner=root:0 --group=root:0 $(PERL_PKG)/
	rm -rf $(PERL_PKG)/

clean-java:
	+$(MAKE) -C java distclean
clean-mono:
	+$(MAKE) -C mono clean
clean-ruby:
	+[ ! -f ruby/Makefile ] || $(MAKE) -C ruby distclean
clean-perl:
	+[ ! -f perl/Makefile ] || $(MAKE) -C perl distclean
clean-php:
	[ ! -f php/configure ] || (cd php && phpize --clean)
clean-python:
	rm -f python/*.pyc

=== debian/changelog ===
rhash (1.4.1-2) unstable; urgency=medium

  * d/patches/0001-v1.4.1.patch fix incorrectly reported version

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Thu, 25 Mar 2021 02:26:02 +0300

rhash (1.4.1-1) unstable; urgency=medium

  * New upstream version 1.4.1
  * d/patches: drop obsolete patch
  * d/control: bump Standards-Version to 4.5.1

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Fri, 08 Jan 2021 05:03:33 +0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Aleksey Kravchenko <rhash.admin@gmail.com>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2), libssl-dev (>= 1.1.0)
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: http://rhash.sourceforge.net
 Vcs-Git: https://salsa.debian.org/pkg-security-team/rhash.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/rhash

## rhash 1.4.2

=== debian/changelog ===
rhash (1.4.2-1ubuntu1) jammy; urgency=medium

  * Load and recommend OpenSSL 3 libaries, not 1.1.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 03 Mar 2022 16:07:36 +1300

rhash (1.4.2-1build1) jammy; urgency=medium

  * No-change rebuild for libssl3 (LP: #1959840)

 -- Dan Bungert <daniel.bungert@canonical.com>  Wed, 02 Feb 2022 11:15:24 -0700

rhash (1.4.2-1) unstable; urgency=medium

  * New upstream version 1.4.2
  * Update pgp signature path in the watch file
  * Drop obsolete patches

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Sun, 29 Aug 2021 23:17:28 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: rhash
 Section: utils
 Priority: optional
-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Aleksey Kravchenko <rhash.admin@gmail.com>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2), libssl-dev (>= 1.1.0)
 Standards-Version: 4.5.1
@@ -13,7 +14,7 @@
 Package: rhash
 Architecture: any
 Depends: librhash0 (>= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
-Recommends: libssl1.1
+Recommends: libssl3
 Description: utility for computing hash sums and magnet links
  RHash is a console utility for calculation and verification of magnet links
  and a wide range of hash sums like CRC32, MD4, MD5, SHA1, SHA256, SHA512,
@@ -33,7 +34,7 @@
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: libssl1.1
+Recommends: libssl3
 Multi-Arch: same
 Description: shared library for hash functions computing
  LibRHash is a professional, portable, thread-safe C library for computing

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/rhash-$1\.tar\.gz/,\
pgpsigurlmangle=s/archive.*\/(v?\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/ \
  https://github.com/rhash/RHash/releases/latest .*/v?(\d\S*)\.tar\.gz

## rhash 1.4.3

=== Makefile ===
--- 
+++ 
@@ -13,18 +13,19 @@
   librhash/byte_order.c librhash/byte_order.h librhash/plug_openssl.c librhash/plug_openssl.h \
   librhash/rhash.c librhash/rhash.h librhash/rhash_torrent.c librhash/rhash_torrent.h \
   librhash/rhash_timing.c librhash/rhash_timing.h \
-  librhash/aich.c librhash/aich.h librhash/crc32.c librhash/crc32.h \
+  librhash/aich.c librhash/aich.h librhash/blake2b.c librhash/blake2b.h \
+  librhash/blake2s.c librhash/blake2s.h librhash/crc32.c librhash/crc32.h \
   librhash/ed2k.c librhash/ed2k.h librhash/edonr.c librhash/edonr.h \
   librhash/gost12.c librhash/gost12.h librhash/gost94.c librhash/gost94.h \
   librhash/has160.c librhash/has160.h librhash/hex.c librhash/hex.h librhash/md4.c \
   librhash/md4.h librhash/md5.c librhash/md5.h librhash/ripemd-160.c librhash/ripemd-160.h \
   librhash/sha1.c librhash/sha1.h librhash/sha3.c librhash/sha3.h \
   librhash/sha256.c librhash/sha256.h librhash/sha512.c librhash/sha512.h \
-  librhash/snefru.c librhash/snefru.h librhash/tiger.c librhash/tiger.h \
-  librhash/tiger_sbox.c librhash/tth.c librhash/tth.h librhash/whirlpool.c \
-  librhash/whirlpool.h librhash/whirlpool_sbox.c librhash/test_hashes.c \
-  librhash/test_hashes.h librhash/torrent.h librhash/torrent.c librhash/ustd.h \
-  librhash/util.h librhash/Makefile
+  librhash/snefru.c librhash/snefru.h librhash/tiger.c librhash/tiger.h librhash/tiger_sbox.c \
+  librhash/torrent.h librhash/torrent.c librhash/tth.c librhash/tth.h \
+  librhash/whirlpool.c librhash/whirlpool.h librhash/whirlpool_sbox.c \
+  librhash/test_lib.c librhash/test_lib.h librhash/ustd.h \
+  librhash/util.c librhash/util.h librhash/Makefile
 I18N_FILES  = po/ca.po po/de.po po/en_AU.po po/es.po po/fr.po po/gl.po po/it.po po/ro.po po/ru.po po/uk.po
 ALL_FILES   = $(SOURCES) $(HEADERS) $(LIBRHASH_FILES) $(OTHER_FILES) $(WIN_DIST_FILES) $(I18N_FILES)
 SPECFILE    = dist/rhash.spec
@@ -212,7 +213,7 @@
 rhash_main.o: rhash_main.c rhash_main.h calc_sums.h common_func.h file.h \
  hash_check.h file_mask.h find_file.h hash_print.h hash_update.h \
  parse_cmdline.h output.h win_utils.h librhash/rhash.h
-	$(CC) -c $(CFLAGS) $< -o $@
+	$(CC) -c $(CFLAGS) $(LOCALECFLAGS) $< -o $@
 
 win_utils.o: win_utils.c win_utils.h common_func.h file.h parse_cmdline.h \
  rhash_main.h
@@ -226,10 +227,10 @@
 	grep -q "APPDATA" dist/rhash.1.win.html
 
 dist/rhash.1.html: dist/rhash.1
-	-which rman 2>/dev/null && (rman -fHTML -roff dist/rhash.1 | sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > $@)
+	-rman --version 2>/dev/null && (rman -fHTML -roff dist/rhash.1 | sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > $@)
 
 dist/rhash.1.txt: dist/rhash.1
-	-which groff &>/dev/null && (groff -t -e -mandoc -Tascii dist/rhash.1 | sed -e 's/.\[[0-9]*m//g' > $@)
+	-groff --version 2>/dev/null && (groff -t -e -mandoc -Tascii dist/rhash.1 | sed -e 's/.\[[0-9]*m//g' > $@)
 
 permissions:
 	find . build dist docs librhash po tests -maxdepth 1 -type f -exec chmod -x '{}' \;
@@ -260,12 +261,15 @@
 	tar cJf $(ARCHIVE_XZ) --owner=root:0 --group=root:0 $(PACKAGE_NAME)/
 	rm -rf $(PACKAGE_NAME)
 
-$(ARCHIVE_ZIP): $(WIN_DIST_FILES) dist/rhash.1.win.html
+win-dir: $(WIN_DIST_FILES) dist/rhash.1.win.html
 	test -s dist/rhash.1.win.html && test -x $(RHASH_BINARY)
 	-rm -rf $(WIN_ZIP_DIR)
 	mkdir $(WIN_ZIP_DIR)
 	cp $(RHASH_BINARY) ChangeLog $(WIN_DIST_FILES) $(WIN_ZIP_DIR)/
 	cp dist/rhash.1.win.html $(WIN_ZIP_DIR)/rhash-doc.html
+
+$(ARCHIVE_ZIP): $(WIN_DIST_FILES) dist/rhash.1.win.html
+	+$(MAKE) win-dir
 	zip -9r $(ARCHIVE_ZIP) $(WIN_ZIP_DIR)
 	rm -rf $(WIN_ZIP_DIR)
 
@@ -289,7 +293,7 @@
 
 clean-local:
 	rm -f *.o $(RHASH_SHARED) $(RHASH_STATIC)
-	rm -f po/*.gmo po/*.po~
+	rm -f po/*.gmo po/*.po~ po/compile-gmo.tag
 
 distclean: clean-local
 	rm -f config.log config.mak $(SPECFILE) $(LIBRHASH_PC)
@@ -305,11 +309,14 @@
 		msgmerge -U $$f po/rhash.pot; \
 	done
 
-compile-gmo:
+po/compile-gmo.tag: $(I18N_FILES)
 	for f in $(I18N_FILES); do \
 		g=`basename $$f .po`; \
 		msgfmt -o po/$$g.gmo $$f; \
 	done
+	touch $@
+
+compile-gmo: po/compile-gmo.tag
 
 install-gmo: compile-gmo
 	for f in $(I18N_FILES); do \
@@ -324,6 +331,3 @@
 	done
 
 .PHONY: all build-shared build-static lib-shared lib-static clean clean-bindings distclean clean-local \
-	test test-shared test-static test-full test-lib test-libs test-lib-shared test-lib-static \
-	install build-install-binary install-binary install-lib-shared install-lib-static \
-	install-lib-headers install-lib-so-link install-conf install-data install-gmo install-man \

=== librhash/Makefile ===
--- 
+++ 
@@ -2,15 +2,15 @@
 
 include config.mak
 
-HEADERS = algorithms.h byte_order.h plug_openssl.h rhash.h rhash_timing.h rhash_torrent.h aich.h crc32.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h sha3.h ripemd-160.h gost12.h gost94.h has160.h snefru.h tiger.h tth.h torrent.h ustd.h util.h whirlpool.h
-SOURCES = algorithms.c byte_order.c plug_openssl.c rhash.c rhash_timing.c rhash_torrent.c aich.c crc32.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c sha3.c ripemd-160.c gost12.c gost94.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c whirlpool.c whirlpool_sbox.c
+HEADERS = algorithms.h byte_order.h plug_openssl.h rhash.h rhash_timing.h rhash_torrent.h aich.h blake2b.h blake2s.h crc32.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h sha3.h ripemd-160.h gost12.h gost94.h has160.h snefru.h tiger.h tth.h torrent.h ustd.h util.h whirlpool.h
+SOURCES = algorithms.c byte_order.c plug_openssl.c rhash.c rhash_timing.c rhash_torrent.c aich.c blake2b.c blake2s.c crc32.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c sha3.c ripemd-160.c gost12.c gost94.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c util.c whirlpool.c whirlpool_sbox.c
 OBJECTS = $(SOURCES:.c=.o)
 LIB_HEADERS = rhash.h rhash_torrent.h
 SO_HEADERS = $(LIB_HEADERS) $(LEGACY_HEADERS)
 TEST_STATIC = test_static$(EXEC_EXT)
 TEST_SHARED = test_shared$(EXEC_EXT)
-INSTALL_DATA    = $(INSTALL) -m 644
-INSTALL_SHARED  = $(INSTALL) -m 644
+INSTALL_DATA = $(INSTALL) -m 644
+INSTALL_SHARED = $(INSTALL) -m $(SHARED_LIB_MODE)
 
 all: $(BUILD_TARGETS)
 lib-static: $(LIBRHASH_STATIC)
@@ -31,10 +31,11 @@
 
 install-implib:
 	$(INSTALL) -d $(LIBDIR)
-	$(INSTALL_SHARED) $(LIBRHASH_IMPLIB) $(LIBDIR)/
+	$(INSTALL_DATA) $(LIBRHASH_IMPLIB) $(LIBDIR)/
 
 install-so-link:
 	$(INSTALL) -d $(LIBDIR)
+	rm -f $(LIBDIR)/$(LIBRHASH_SOLINK)
 	ln -s $(LIBRHASH_SHARED) $(LIBDIR)/$(LIBRHASH_SOLINK)
 
 uninstall-lib-static: uninstall-lib-headers
@@ -71,6 +72,12 @@
  tth.h whirlpool.h
 	$(CC) -c $(CFLAGS) $< -o $@
 
+blake2b.o: blake2b.c blake2b.h ustd.h byte_order.h
+	$(CC) -c $(CFLAGS) $< -o $@
+
+blake2s.o: blake2s.c blake2s.h ustd.h byte_order.h
+	$(CC) -c $(CFLAGS) $< -o $@
+
 byte_order.o: byte_order.c byte_order.h ustd.h
 	$(CC) -c $(CFLAGS) $< -o $@
 
@@ -107,7 +114,7 @@
 
 rhash.o: rhash.c byte_order.h ustd.h algorithms.h rhash.h torrent.h \
  sha1.h plug_openssl.h util.h hex.h
-	$(CC) -c $(CFLAGS) $< -o $@
+	$(CC) -c $(CFLAGS) $(VERSION_CFLAGS) $< -o $@
 
 rhash_timing.o: rhash_timing.c byte_order.h ustd.h rhash.h rhash_timing.h
 	$(CC) -c $(CFLAGS) $< -o $@
@@ -134,8 +141,8 @@
 snefru.o: snefru.c byte_order.h ustd.h snefru.h
 	$(CC) -c $(CFLAGS) $< -o $@
 
-test_hashes.o: test_hashes.c byte_order.h ustd.h rhash_timing.h \
- rhash_torrent.h rhash.h test_hashes.h
+test_lib.o: test_lib.c byte_order.h ustd.h rhash_timing.h \
+ rhash_torrent.h rhash.h test_lib.h util.h
 	$(CC) -c $(CFLAGS) $< -o $@
 
 tiger.o: tiger.c byte_order.h ustd.h tiger.h
@@ -149,6 +156,9 @@
 	$(CC) -c $(CFLAGS) $< -o $@
 
 tth.o: tth.c byte_order.h ustd.h tth.h tiger.h
+	$(CC) -c $(CFLAGS) $< -o $@
+
+util.o: util.c util.h
 	$(CC) -c $(CFLAGS) $< -o $@
 
 whirlpool.o: whirlpool.c byte_order.h ustd.h whirlpool.h
@@ -166,18 +176,19 @@
 	ln -s $(LIBRHASH_SHARED) $(LIBRHASH_SOLINK)
 
 $(LIBRHASH_SHARED): $(SOURCES) $(EXPORTS_TARGET) $(SOLINK_TARGET)
-	$(CC) $(SHARED_CFLAGS) $(SOURCES) $(SHARED_LDFLAGS) -o $@
+	$(CC) $(SHARED_CFLAGS) $(VERSION_CFLAGS) $(SOURCES) $(SHARED_LDFLAGS) -o $@
 
 # build static library
 $(LIBRHASH_STATIC): $(OBJECTS)
-	$(AR) cqs $@ $(OBJECTS)
+	rm -f $@
+	$(AR) -cqs $@ $(OBJECTS)
 
 # test targets
-$(TEST_SHARED): $(LIBRHASH_SHARED) test_hashes.o
-	$(CC) $(CFLAGS) test_hashes.o $(LIBRHASH_SHARED) $(LDFLAGS) -o $@
-
-$(TEST_STATIC): $(LIBRHASH_STATIC) test_hashes.o
-	$(CC) $(CFLAGS) test_hashes.o $(LIBRHASH_STATIC) $(BIN_STATIC_LDFLAGS) -o $@
+$(TEST_SHARED): $(LIBRHASH_SHARED) test_lib.o
+	$(CC) $(CFLAGS) test_lib.o $(LIBRHASH_SHARED) $(LDFLAGS) -o $@
+
+$(TEST_STATIC): $(LIBRHASH_STATIC) test_lib.o
+	$(CC) $(CFLAGS) test_lib.o $(LIBRHASH_STATIC) $(BIN_STATIC_LDFLAGS) -o $@
 
 test: $(TEST_TARGETS)
 test-static: $(TEST_STATIC)

=== bindings/mono/test/Makefile ===
#!/usr/bin/make -f

# This file is a part of Mono Bindings for Librhash
#
# Copyright (c) 2011, Sergey Basalaev <sbasalaev@gmail.com>
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
# REGARD TO THIS SOFTWARE  INCLUDING ALL IMPLIED WARRANTIES OF  MERCHANTABILITY
# AND FITNESS.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
# INDIRECT,  OR CONSEQUENTIAL DAMAGES  OR ANY DAMAGES WHATSOEVER RESULTING FROM
# LOSS OF USE,  DATA OR PROFITS,  WHETHER IN AN ACTION OF CONTRACT,  NEGLIGENCE
# OR OTHER TORTIOUS ACTION,  ARISING OUT OF  OR IN CONNECTION  WITH THE USE  OR
# PERFORMANCE OF THIS SOFTWARE.

MONO?=mono
CS?=mcs
MONO_PATH?=..

test: Test.exe
	MONO_PATH="$(MONO_PATH)" $(MONO) Test.exe

Test.exe: Test.cs
	$(CS) -r:RHash.dll -lib:.. Test.cs

clean:
	rm -f Test.exe

=== debian/changelog ===
rhash (1.4.3-3) unstable; urgency=medium

  * d/watch: Drop filenamemangle option, as recommended by lintian
  * d/patches: Fix build on sparc64 arch

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Sun, 17 Jul 2022 02:42:55 +0300

rhash (1.4.3-2) unstable; urgency=medium

  * d/control: Switch to libssl3 in B-Depends and Recommends
    (Closes: #1012698, #1011474)
  * d/patches:
    - Fix export of BTIH context
    - Fix libcrypto dynamic loading by reordering library filenames

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Tue, 28 Jun 2022 22:43:53 +0300

rhash (1.4.3-1) unstable; urgency=medium

  * New upstream release version 1.4.3
  * librhash0.symbols: added 4 functions
  * d/copyright: update copyright year
  * d/control: bump std-version to 4.6.1.0
  * d/patches:
    - Fix incorrectly reported version
    - Fix localization

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Thu, 23 Jun 2022 22:06:32 +0300

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: rhash
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Aleksey Kravchenko <rhash.admin@gmail.com>
-Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2), libssl-dev (>= 1.1.0)
-Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2), libssl-dev (>= 3.0.0)
+Standards-Version: 4.6.1
 Homepage: http://rhash.sourceforge.net
 Vcs-Git: https://salsa.debian.org/pkg-security-team/rhash.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/rhash

=== debian/tests/control ===
Test-Command: tests/test_rhash.sh /usr/bin/rhash

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/archive\/refs\/tags\/(v?\d\S+).tar.gz/releases\/download\/$1\/$1.tar.gz.asc/" \
  https://github.com/rhash/RHash/tags .*/v(\d\S+)\.tar\.gz

## rhash 1.4.4

=== debian/changelog ===
rhash (1.4.4-3) unstable; urgency=medium

  * d/patches: Fix build on hurd archs

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Tue, 01 Oct 2024 03:20:08 +0300

rhash (1.4.4-2) unstable; urgency=medium

  * d/control: bump std-version to 4.7.0
  * d/copyright: update copyright year to 2024

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Tue, 01 Oct 2024 00:55:30 +0300

rhash (1.4.4-1) experimental; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)

  [ Aleksey Kravchenko ]
  * New upstream version 1.4.4 (Closes: #1025999)
  * Bump librhash soname
  * d/control: bump std-version to 4.6.2
  * d/copyright: update copyright year
  * Override the hardening-no-fortify-functions lintian warning
  * d/patches:
    - Drop obsolete patches
    - Fix backslash in the rhash.1 manpage

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Mon, 17 Jul 2023 07:49:58 +0300
